// lib.h

#ifndef __LIB_H__
#define __LIB_H__
#ifdef __cplusplus
extern "C" {
#endif


#define MAX_DMA_CHAIN 8

#define ADR_SRAM     (u8*)0xE000000
#define ADR_EWRAM    (u8*)&__exidx_start;

//L[͂̃EFCg
#define KEY_REPEAT_TIME			10
#define TIMER_INTMS				10

// TODO 08/02 L[\̂QłĂ̂ŁAŒ
//            ST_INPUT\̂ƕϐgȂ`ŁB

//BG
EWRAM_CODE void BGSetPal16(u16 No, u16 *pal);
EWRAM_CODE void BGSetPal256(u16 *pal);
EWRAM_CODE void BGSetPalMap(u8 No,u32 size, u16 pal);
EWRAM_CODE void BGSetChrData(u8 No,u16 *img,u32 size);
EWRAM_CODE void BGSetMapData(u8 No,u16 *img,u32 size);
EWRAM_CODE void BGSetScroll(u8 No, u16 x, u16 y);
EWRAM_CODE void BGDrawStr(u8 BG,u16 x,u16 y,u8* str);
EWRAM_CODE void BGDrawChar(u8 No, u16 x,u16 y,u16 palno,u16 chr);
EWRAM_CODE void BGDrawCls(u8 BG, u16 chr);
EWRAM_CODE void BGDrawBox(u8 BG, u16 x, u16 y, u16 stopX, u16 stopY, u16 chr);
EWRAM_CODE void BGDrawOrder(u8 BG);
EWRAM_CODE u16  BGGetChar(u8 No, u8 x, u8 y);
EWRAM_CODE void BGSetChar(u8 No, u8 x, u8 y, u16 chr);

//Mode3
EWRAM_CODE u16  Mode3GetDotRGB(u8 ,u8);
EWRAM_CODE void Mode3DrawCls(u16);
EWRAM_CODE void Mode3DrawDot(u8, u8, u16);
EWRAM_CODE void Mode3DrawLine(u8, u8, u8, u8, u16);
EWRAM_CODE void Mode3DrawBox(u8, u8, u8, u8, u16);
EWRAM_CODE void Mode3DrawCircle(u16, u16, u16, u16);
EWRAM_CODE void Mode3DrawFillCircle(u16, u16, u16, u16);
EWRAM_CODE void Mode3DrawImage(u8 x, u8 y, u8 cx,u8 cy,u16* image);
//Mode3 Font BitMap
EWRAM_CODE void Mode3SetBitMapFont(u8 *offset, u16 cx, u16 cy);
EWRAM_CODE void Mode3DrawBitMapStr(u8 x,u8 y, u8* str);
EWRAM_CODE void Mode3DrawBitMapChar(u8 x,u8 y,u16 chr);
//Mode3 Font SJIS
EWRAM_CODE void Mode3SetSJISFont(u8* sheet, u8* offset, u16 cnt, u8 cx, u8 cy);
EWRAM_CODE void Mode3DrawSJISStr(u8 x,u8 y,u8* texts,u16 color);
EWRAM_CODE void Mode3DrawSJISChar(u8 x, u8 y, u16 num, u16 col);
EWRAM_CODE void Mode3DrawSJIS(u8 x, u8 y, u8* chr, u16 col); //2Bytep
EWRAM_CODE void Mode3DrawSJISAscii(u8 x, u8 y, u16 num, u16 col);
EWRAM_CODE void Mode3DrawSJISBlock(u8 font,int x1,int y1,u16 color);
//Mode3 Effect
//void Mode3DrawFadeOut();
//void Mode3DrawFadeIn();



//Sprite
EWRAM_CODE void SpriteInit();
EWRAM_CODE void SpriteSetPal16(u16 *pal);
EWRAM_CODE void SpriteSetPal16No(u16 num, u16 palno);
EWRAM_CODE void SpriteSetPal256(u16 *pal);
EWRAM_CODE void SpriteSetData(u16 *img,u32 size);
EWRAM_CODE void SpriteSetSize(u16 num,u16 size,u16 form,u16 color);
EWRAM_CODE void SpriteSetChr(u16 num, u16 ch);
EWRAM_CODE void SpriteSetPriority(u16 num, u16 priority);
EWRAM_CODE void SpriteSetVertical(u16 num, u8 flag);
EWRAM_CODE void SpriteSetRotate(u16 num, u8 angle, u16 Scale);
EWRAM_CODE void SpriteSetRotateFlag(u16 num, u16 no, u16 double_flag);
EWRAM_CODE void SpriteSetScale(u16 num, u16 xscale, u16 yscale);
EWRAM_CODE void SpriteMove(u16 num, s16 x, s16 y);


//Sound
EWRAM_CODE void SoundInit();
EWRAM_CODE void SoundSetData(s8 *offset, u32 size);
EWRAM_CODE void SoundStart();
EWRAM_CODE void SoundStop();



//L[
EWRAM_CODE void KeyInit();
EWRAM_CODE u16  KeyInput();
EWRAM_CODE bool KeyWaitTimer();
EWRAM_CODE bool KeyRepeat();
EWRAM_CODE u8   KeyGet();


//fobN
EWRAM_CODE void cprint(char* sz);
EWRAM_CODE void cprintf(u32 hex);
EWRAM_CODE void DebugMessage(u8* msg);
//void DebufAssert(hoge);


//DMA]
EWRAM_CODE void DMA3MemcpyFIX16(u32, u32, u16);
EWRAM_CODE void DMA3MemcpyINC16(u32, u32, u16);
EWRAM_CODE void DMA3MemcpyINC32(u32, u32, u16);



//DMAChain
EWRAM_CODE void DMAChainInit();
EWRAM_CODE void DMAChainEnqueue(u32 src, u32 dst, u16 size, u16 mode);
EWRAM_CODE void DMAChainTransfer();


//
EWRAM_CODE void *_malloc(u32 size);
EWRAM_CODE void _mfree(void *ptr);



//EFCg
EWRAM_CODE void WaitKey(u16);
EWRAM_CODE void WaitKey2(u16);
EWRAM_CODE void WaitMs(u32 wait);


//̑
EWRAM_CODE void  WaitForVsync();
EWRAM_CODE char* bprintf(char *p, char *fmt, ...);

EWRAM_CODE s16   _Sin(u8);
EWRAM_CODE s16   _Cos(u8);
EWRAM_CODE u8    _Angle(s16 dx, s16 dy);

EWRAM_CODE u8 HitChkBox(u16 srcX, u16 srcY, u16 srcCx, u16 srcCy, u16 dstX, u16 dstY, u16 dstCx,u16 dstCy);
EWRAM_CODE u8 HitChkCircle(u16 srcX, u16 srcY, u16 srcR, u16 dstX, u16 dstY, u16 dstR);

EWRAM_CODE void HexToStr(u32 hex, u8* s);

// ExtendTinyFileSystem
EWRAM_CODE u8*  EtfsOffset(u32 data_offset);
//u8*  Etfsfopen(u32 offset, u32 size);
EWRAM_CODE u8*  EtfsfopenLZ77(u32 offset, u32 size);
EWRAM_CODE u8   EtfsReadu8(u32);
EWRAM_CODE u16  EtfsReadu16(u32);
EWRAM_CODE u32  EtfsReadu32(u32);



//Seek
EWRAM_CODE void SeekSetChr(u8* pOffset, u32 size, u8 chr);
EWRAM_CODE u8*  SeekNext();
EWRAM_CODE u8*  SeekPrev();
EWRAM_CODE u8   SeekHasMore();
EWRAM_CODE u8*  SeekGetNow();



//SRAM
EWRAM_CODE u8*  SRAMGetOffset(u32);
EWRAM_CODE u8   SRAMRead8 (u32);
EWRAM_CODE u16  SRAMRead16(u32);
EWRAM_CODE u32  SRAMRead32(u32);
EWRAM_CODE void SRAMWrite8 (u32,u8);
EWRAM_CODE void SRAMWrite16(u32,u16);
EWRAM_CODE void SRAMWrite32(u32,u32);
//u8 SRAMComp8 (u32,u8);
//u8 SRAMComp16(u32,u16);
//u8 SRAMComp32(u32,u32);

typedef struct{
	u16* offset;
	u16  cx;
	u16  cy;
	u16  size;
} ST_FONTBITMAP;

typedef struct{
	u16* FontSheet;
	u8*  Offset;
	u16  cx;
	u16  cy;
	u16  size;
	u16  cnt;
} ST_FONTSJIS;

typedef struct{
	s8  *Offset;
	u32 size;
} ST_WAVE;

typedef struct{
	u16 cur;
	u16 old;
	u16 trg;
	u16 off;
} ST_KEY;

typedef struct{
	u8* Now;
	u8* Start;
	u8* End;
	u8  Chr;
} ST_SEEK;

typedef struct {
	u32 src;
	u32 dst;
	u16 size;
	u16 mode;
} ST_DMA_CHAIN;

typedef struct {
	vu32 clockTick;
	vu32 wait;
	vu32 repeat;
} ST_TIMER;

typedef struct {
	u8 Chr;
	u8 Map;
	u8 Col;
} ST_BG; //Cuł͎gĂȂ

typedef struct {
	u8 keyNow;							//݂̓
	u8 keyOld;							//1O̓
} ST_INPUT;


#ifdef __cplusplus
}
#endif
#endif

